# -*- coding: utf-8 -*-

def IOU(Reframe=[],GTframe=[]):
    """
    计算两矩形 IOU，传入为均为矩形每条对角线，（x,y）  坐标。
    """
    #矩形框1
    x1 = Reframe[0]
    y1 = Reframe[1]
    width1 = Reframe[2]-Reframe[0]
    height1 = Reframe[3]-Reframe[1]
    
    #矩形框2
    x2 = GTframe[0]
    y2 = GTframe[1]
    width2 = GTframe[2]-GTframe[0]
    height2 = GTframe[3]-GTframe[1]

    endx = max(x1+width1,x2+width2)
    startx = min(x1,x2)
    width = width1+width2-(endx-startx)

    endy = max(y1+height1,y2+height2)
    starty = min(y1,y2)
    height = height1+height2-(endy-starty)

    if width <=0 or height <= 0:
        ratio = 0 # 重叠率为 0 
    else:
        Area = width*height # 两矩形相交面积
        Area1 = width1*height1
        Area2 = width2*height2
        ratio = Area*1./(Area1+Area2-Area)
    #print "IOU is %f"%ratio
    return ratio#,Reframe,GTframe

if __name__ == '__main__':
    IOU()